var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
export default (function (context) { return function (_a) {
    var name = _a.name, step = _a.step;
    return function (WrapperComponent) { return function (_a) {
        var onStepFinished = _a.onStepFinished, props = __rest(_a, ["onStepFinished"]);
        return (React.createElement(context.Consumer, null, function (_a) {
            var finishStep = _a.finishStep, currentSteps = _a.currentSteps, isFinishing = _a.isFinishing;
            if (currentSteps.indexOf(step) === -1) {
                return null;
            }
            var finishStepFunction = function (result) { return finishStep(step, result, onStepFinished); };
            return (React.createElement(WrapperComponent, __assign({ name: name, currentSteps: currentSteps, finishStep: finishStepFunction, isFinishing: isFinishing }, props)));
        }));
    }; };
}; });
//# sourceMappingURL=createWithAlgorithm.js.map