var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
export default (function (context) {
    return /** @class */ (function (_super) {
        __extends(AlgorithmProvider, _super);
        function AlgorithmProvider(props) {
            var _this = _super.call(this, props) || this;
            _this.finishStep = function (step, result, onStepFinished) {
                var index = _this.state.currentSteps.indexOf(step);
                if (index === -1) {
                    return;
                }
                _this.props.algorithm(step, result).then(function (stepsToAppend) {
                    var currentSteps = _this.state.currentSteps.slice();
                    currentSteps = currentSteps.concat(stepsToAppend);
                    currentSteps.splice(index, 1);
                    _this.setState({
                        currentSteps: currentSteps,
                        isFinishing: false
                    });
                    onStepFinished && onStepFinished(result);
                });
                _this.setState({
                    isFinishing: true
                });
            };
            _this.state = {
                steps: props.steps,
                currentSteps: [props.initialStep],
                isFinishing: false,
            };
            return _this;
        }
        AlgorithmProvider.prototype.render = function () {
            var _a = this.state, currentSteps = _a.currentSteps, isFinishing = _a.isFinishing;
            return (React.createElement(context.Provider, { value: {
                    currentSteps: currentSteps,
                    isFinishing: isFinishing,
                    finishStep: this.finishStep
                } }, this.props.children));
        };
        return AlgorithmProvider;
    }(React.Component));
});
//# sourceMappingURL=createAlgorithmProvider.js.map